/*!
 * vuex-class v0.1.0
 * https://github.com/ktsn/vuex-class
 *
 * @license
 * Copyright (c) 2017 katashin
 * Released under the MIT license
 * https://github.com/ktsn/vuex-class/blob/master/LICENSE
 */
(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('vue-class-component'), require('vuex')) :
	typeof define === 'function' && define.amd ? define(['exports', 'vue-class-component', 'vuex'], factory) :
	(factory((global.VuexClass = global.VuexClass || {}),global.VueClassComponent,global.Vuex));
}(this, (function (exports,vueClassComponent,vuex) { 'use strict';

var State = function (value, options) {
    var namespace = options && options.namespace;
    return vueClassComponent.createDecorator(function (componentOptions, key) {
        if (!componentOptions.computed) {
            componentOptions.computed = {};
        }
        var mapObject = (_a = {}, _a[key] = value, _a);
        componentOptions.computed[key] = namespace !== undefined
            ? vuex.mapState(namespace, mapObject)[key]
            : vuex.mapState(mapObject)[key];
        var _a;
    });
};
var Getter = createBindingHelper('computed', function (type) {
    return function () {
        return this.$store.getters[type];
    };
});
var Action = createBindingHelper('methods', function (type) {
    return function (payload) {
        return this.$store.dispatch(type, payload);
    };
});
var Mutation = createBindingHelper('methods', function (type) {
    return function (payload) {
        return this.$store.commit(type, payload);
    };
});
function namespace(namespace, helper) {
    return function (typeOrFn) {
        return helper(typeOrFn, { namespace: namespace });
    };
}
function createBindingHelper(bindTo, fn) {
    return function (type, options) {
        var namespace = extractNamespace(options);
        return vueClassComponent.createDecorator(function (componentOptions, key) {
            if (!componentOptions[bindTo]) {
                componentOptions[bindTo] = {};
            }
            componentOptions[bindTo][key] = fn(namespace + type);
        });
    };
}
function extractNamespace(options) {
    var n = options && options.namespace;
    if (typeof n !== 'string') {
        return '';
    }
    if (n[n.length - 1] !== '/') {
        return n + '/';
    }
    return n;
}

exports.State = State;
exports.Getter = Getter;
exports.Action = Action;
exports.Mutation = Mutation;
exports.namespace = namespace;

Object.defineProperty(exports, '__esModule', { value: true });

})));
