import { createDecorator } from 'vue-class-component';
import { mapState } from 'vuex';
export var State = function (value, options) {
    var namespace = options && options.namespace;
    return createDecorator(function (componentOptions, key) {
        if (!componentOptions.computed) {
            componentOptions.computed = {};
        }
        var mapObject = (_a = {}, _a[key] = value, _a);
        componentOptions.computed[key] = namespace !== undefined
            ? mapState(namespace, mapObject)[key]
            : mapState(mapObject)[key];
        var _a;
    });
};
export var Getter = createBindingHelper('computed', function (type) {
    return function () {
        return this.$store.getters[type];
    };
});
export var Action = createBindingHelper('methods', function (type) {
    return function (payload) {
        return this.$store.dispatch(type, payload);
    };
});
export var Mutation = createBindingHelper('methods', function (type) {
    return function (payload) {
        return this.$store.commit(type, payload);
    };
});
export function namespace(namespace, helper) {
    return function (typeOrFn) {
        return helper(typeOrFn, { namespace: namespace });
    };
}
function createBindingHelper(bindTo, fn) {
    return function (type, options) {
        var namespace = extractNamespace(options);
        return createDecorator(function (componentOptions, key) {
            if (!componentOptions[bindTo]) {
                componentOptions[bindTo] = {};
            }
            componentOptions[bindTo][key] = fn(namespace + type);
        });
    };
}
function extractNamespace(options) {
    var n = options && options.namespace;
    if (typeof n !== 'string') {
        return '';
    }
    if (n[n.length - 1] !== '/') {
        return n + '/';
    }
    return n;
}
